﻿<%@ Page Language="VB" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    Protected Sub sds_Updated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceStatusEventArgs)
        If e.AffectedRows = 0 Then
            Response.Write("データ競合が発生しました")
        End If
    End Sub
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>GridViewコントロール</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:DropDownList ID="lstPub" runat="server" DataSourceID="sds_select" DataTextField="publish"
            DataValueField="publish" AutoPostBack="True">
        </asp:DropDownList><asp:SqlDataSource ID="sds_select" runat="server" ConnectionString="<%$ ConnectionStrings:myDb %>"
            SelectCommand="SELECT DISTINCT [publish] FROM [books]" DataSourceMode="DataReader"></asp:SqlDataSource>
        <asp:GridView ID="grid" runat="server" AllowPaging="True" AllowSorting="True"
            AutoGenerateColumns="False" CellPadding="4" DataKeyNames="isbn,updated" DataSourceID="sds"
            ForeColor="#333333" GridLines="None">
            <FooterStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
            <Columns>
                <asp:ImageField DataAlternateTextField="title" DataAlternateTextFormatString="{0}"
                    DataImageUrlField="isbn" DataImageUrlFormatString="http://www.wings.msn.to/books/{0}/{0}_logo.jpg"
                    HeaderText="ロゴ" ReadOnly="True">
                </asp:ImageField>
                <asp:HyperLinkField DataNavigateUrlFields="isbn" DataNavigateUrlFormatString="http://www.wings.msn.to/index.php/-/A-03/{0}/"
                    DataTextField="isbn" DataTextFormatString="ISBN{0}" HeaderText="ISBNコード" SortExpression="isbn"
                    Target="_blank" />
                <asp:BoundField DataField="title" HeaderText="書名" SortExpression="title" />
                <asp:BoundField DataField="publish" HeaderText="出版社" SortExpression="publish" />
                <asp:TemplateField HeaderText="単価" SortExpression="price">
                    <EditItemTemplate>
                        <asp:TextBox ID="txtPrice" runat="server" Text='<%# Bind("price") %>' Columns="5"></asp:TextBox>円<asp:RangeValidator
                            ID="rngPrice" runat="server" ControlToValidate="txtPrice" Display="Dynamic" ErrorMessage="価格は正数で指定してください。"
                            MaximumValue="99999" MinimumValue="1" SetFocusOnError="True" Type="Integer">*</asp:RangeValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label1" runat="server" Text='<%# Bind("price", "{0:#,###円}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="刊行日" SortExpression="publishDate">
                    <EditItemTemplate>
                        <asp:TextBox ID="txtPublished" runat="server" Text='<%# Bind("publishDate", "{0:yyyy/MM/dd}") %>'></asp:TextBox>
                        <asp:CompareValidator ID="cmpPublished" runat="server" ControlToValidate="txtPublished"
                            Display="Dynamic" ErrorMessage="刊行日は日付形式で入力してください。" Operator="DataTypeCheck"
                            SetFocusOnError="True" Type="Date">*</asp:CompareValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label2" runat="server" Text='<%# Bind("publishDate", "{0:yyyy年MM月dd日}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:CommandField ButtonType="Button" ShowDeleteButton="True" ShowEditButton="True" />
            </Columns>
            <RowStyle BackColor="#E3EAEB" />
            <EditRowStyle BackColor="#7C6F57" />
            <SelectedRowStyle BackColor="#C5BBAF" Font-Bold="True" ForeColor="#333333" />
            <PagerStyle BackColor="#666666" ForeColor="White" HorizontalAlign="Center" />
            <HeaderStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
            <AlternatingRowStyle BackColor="White" />
        </asp:GridView>
        <asp:SqlDataSource ID="sds" runat="server" ConnectionString="<%$ ConnectionStrings:myDb %>"
            DeleteCommand="DELETE FROM [books] WHERE [isbn] = @original_isbn AND [updated] = @original_updated"
            InsertCommand="INSERT INTO [books] ([isbn], [title], [price], [publish], [publishDate]) VALUES (@isbn, @title, @price, @publish, @publishDate)"
            OldValuesParameterFormatString="original_{0}" SelectCommand="SELECT [isbn], [title], [price], [publish], [publishDate], [updated] FROM [books] WHERE ([publish] = @publish)"
            UpdateCommand="UPDATE [books] SET [title] = @title, [price] = @price, [publish] = @publish, [publishDate] = @publishDate WHERE [isbn] = @original_isbn AND [updated] = @original_updated" OnUpdated="sds_Updated">
            <DeleteParameters>
                <asp:Parameter Name="original_isbn" Type="String" />
                <asp:Parameter Name="original_updated" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="title" Type="String" />
                <asp:Parameter Name="price" Type="Int32" />
                <asp:Parameter Name="publish" Type="String" />
                <asp:Parameter Name="publishDate" Type="DateTime" />
                <asp:Parameter Name="original_isbn" />
                <asp:Parameter Name="original_updated" />
            </UpdateParameters>
            <SelectParameters>
                <asp:ControlParameter ControlID="lstPub" Name="publish" PropertyName="SelectedValue"
                    Type="String" />
            </SelectParameters>
            <InsertParameters>
                <asp:Parameter Name="isbn" Type="String" />
                <asp:Parameter Name="title" Type="String" />
                <asp:Parameter Name="price" Type="Int32" />
                <asp:Parameter Name="publish" Type="String" />
                <asp:Parameter Name="publishDate" Type="DateTime" />
            </InsertParameters>
        </asp:SqlDataSource>
    
    </div>
    </form>
</body>
</html>
